import math

class Vector2D(object):
	def __init__(self, x, y):
		self._x = float(x)
		self._y = float(y)
		
	@property
	def x(self):
		return self._x
		
	@property
	def y(self):
		return self._y
	
	@x.setter
	def x(self, value):
		self._x = float(value)
		
	@y.setter
	def y(self, value):
		self._y = float(value)
	
	@property
	def mag(self):
		return math.sqrt(math.pow(self._x, 2) + math.pow(self._y, 2))

	def copy(self):
		return Vector2D(self._x, self._y)
	
	def normalize_ip(self):
		mag = self.mag
		if mag != 0:
			self._x /= mag
			self._y /= mag
		return self
		
	def scale_ip(self, value):
		self._x *= value
		self._y *= value
		return self
		
	def subtract(self, other):
		return Vector2D(self._x - other._x, self._y - other._y)
	
	def add_ip(self, other):
		self._x += other._x
		self._y += other._y
		return self
		
	def add(self, other):
		return Vector2D(self._x + other._x, self._y + other._y)
		
	def __str__(self):
		return 'Vector2D[%s, %s]' % (self._x, self._y)
	
if __name__ == '__main__':
	p1 = (1., 0.)
	p2 = (100., 100.)
	
	#deltaY = p2[1] - p1[1]
	#deltaX = p2[0] - p1[0]	
	#print deltaX, deltaY	
	#rad = math.atan2(deltaY, deltaX)	
	#print rad
	#print math.degrees(rad)

	rad = math.atan2(p2[1],p2[0]) - math.atan2(p1[1],p1[0])
	
	x = math.cos(rad) 
	y = math.sin(rad)
	
	print '%.2f %.2f %.2f' % (math.degrees(rad), x, y)
	
	#angleInDegrees = arctan(deltaY / deltaX)
	
